Index: codes/icosagcm/trunk/src/geometry.f90
===================================================================
--- codes/icosagcm/trunk/src/geometry.f90	(revision 185)
+++ codes/icosagcm/trunk/src/geometry.f90	(revision 186)
@@ -25,26 +25,47 @@
   END TYPE t_geometry    
 
-  TYPE(t_geometry),TARGET :: geom
+  TYPE(t_geometry),SAVE,TARGET :: geom
+
   
   REAL(rstd),POINTER :: Ai(:)          ! area of a cell
+!$OMP THREADPRIVATE(Ai)
   REAL(rstd),POINTER :: xyz_i(:,:)     ! coordinate of the center of the cell (voronoi)
+!$OMP THREADPRIVATE(xyz_i)
   REAL(rstd),POINTER :: centroid(:,:)  ! coordinate of the centroid of the cell
+!$OMP THREADPRIVATE(centroid)
   REAL(rstd),POINTER :: xyz_e(:,:)     ! coordinate of a wind point on the cell on a edge
+!$OMP THREADPRIVATE(xyz_e)
   REAL(rstd),POINTER :: ep_e(:,:)      ! perpendicular unit vector of a edge (outsider)
+!$OMP THREADPRIVATE(ep_e)
   REAL(rstd),POINTER :: et_e(:,:)      ! tangeantial unit vector of a edge
+!$OMP THREADPRIVATE(et_e)
   REAL(rstd),POINTER :: elon_i(:,:)    ! unit longitude vector on the center 
+!$OMP THREADPRIVATE(elon_i)
   REAL(rstd),POINTER :: elat_i(:,:)    ! unit latitude vector on the center 
+!$OMP THREADPRIVATE(elat_i)
   REAL(rstd),POINTER :: elon_e(:,:)    ! unit longitude vector on a wind point 
+!$OMP THREADPRIVATE(elon_e)
   REAL(rstd),POINTER :: elat_e(:,:)    ! unit latitude vector on a wind point
+!$OMP THREADPRIVATE(elat_e)
   REAL(rstd),POINTER :: xyz_v(:,:)     ! coordinate of a vertex (center of the dual mesh)
+!$OMP THREADPRIVATE(xyz_v)
   REAL(rstd),POINTER :: Av(:)          ! area of dual mesk cell
+!$OMP THREADPRIVATE(Av)
   REAL(rstd),POINTER :: de(:)          ! distance from a neighbour == lenght of an edge of the dual mesh
+!$OMP THREADPRIVATE(de)
   REAL(rstd),POINTER :: le(:)          ! lenght of a edge
+!$OMP THREADPRIVATE(le)
   REAL(rstd),POINTER :: Riv(:,:)       ! weight
+!$OMP THREADPRIVATE(Riv)
   REAL(rstd),POINTER :: Riv2(:,:)      ! weight
+!$OMP THREADPRIVATE(Riv2)
   INTEGER,POINTER    :: ne(:,:)        ! convention for the way on the normal wind on an edge 
+!$OMP THREADPRIVATE(ne)
   REAL(rstd),POINTER :: Wee(:,:,:)     ! weight
+!$OMP THREADPRIVATE(Wee)
   REAL(rstd),POINTER :: bi(:)          ! orographie
+!$OMP THREADPRIVATE(bi)
   REAL(rstd),POINTER :: fv(:)          ! coriolis (evaluted on a vertex)
+!$OMP THREADPRIVATE(fv)
      
 
@@ -91,5 +112,5 @@
   IMPLICIT NONE
     INTEGER,INTENT(IN) :: ind
-!$OMP MASTER
+!!$OMP MASTER
     Ai=geom%Ai(ind)
     xyz_i=geom%xyz_i(ind)
@@ -112,6 +133,6 @@
     bi=geom%bi(ind)
     fv=geom%fv(ind)
-!$OMP END MASTER
-!$OMP BARRIER    
+!!$OMP END MASTER
+!!$OMP BARRIER    
   END SUBROUTINE swap_geometry
 
@@ -127,10 +148,21 @@
     REAL(rstd) :: vect(3,6)
     REAL(rstd) :: centr(3)
-
     INTEGER :: ind,i,j,n,k
-
-    CALL transfert_request(geom%xyz_i,req_i1)
+    TYPE(t_message),SAVE :: message
+    LOGICAL, SAVE :: first=.TRUE.
+!$OMP THREADPRIVATE(first)    
+    
+    IF (first) THEN
+      CALL init_message(geom%xyz_i, req_i1 ,message)
+      first=.FALSE.
+    ENDIF
+    
+    CALL transfert_message(geom%xyz_i,message)
+        
+    
+!    CALL transfert_request(geom%xyz_i,req_i1)
 
     DO ind=1,ndomain
+      IF (.NOT. assigned_domain(ind)) CYCLE
       CALL swap_dimensions(ind)
       CALL swap_geometry(ind)
@@ -157,5 +189,5 @@
   USE transfert_mod
   USE vector
-  USE ioipsl
+  USE getin_mod
   IMPLICIT NONE
     INTEGER :: nb_it=0
@@ -172,4 +204,5 @@
     
     DO ind=1,ndomain
+      IF (.NOT. assigned_domain(ind)) CYCLE
       d=>domain(ind)
       CALL swap_dimensions(ind)
@@ -186,4 +219,5 @@
 
     DO ind=1,ndomain
+      IF (.NOT. assigned_domain(ind)) CYCLE
       d=>domain(ind)
       CALL swap_dimensions(ind)
@@ -215,4 +249,5 @@
       sum=0
       DO ind=1,ndomain
+      IF (.NOT. assigned_domain(ind)) CYCLE
         CALL swap_dimensions(ind)
         CALL swap_geometry(ind)
@@ -253,5 +288,5 @@
   USE dimensions
   USE transfert_mod
-  USE ioipsl
+  USE getin_mod
   IMPLICIT NONE
 
@@ -273,4 +308,5 @@
  
     DO ind=1,ndomain
+      IF (.NOT. assigned_domain(ind)) CYCLE
       d=>domain(ind)
       CALL swap_dimensions(ind)
@@ -489,6 +525,8 @@
                  
     ENDDO
+
     CALL transfert_request(geom%Ai,req_i1)
     CALL transfert_request(geom%centroid,req_i1)
+
     CALL surf_triangle(d%xyz(:,ii_begin,jj_begin),d%xyz(:,ii_begin,jj_end),d%xyz(:,ii_end,jj_begin),S)
  
Index: codes/icosagcm/trunk/src/geopotential_mod.f90
===================================================================
--- codes/icosagcm/trunk/src/geopotential_mod.f90	(revision 185)
+++ codes/icosagcm/trunk/src/geopotential_mod.f90	(revision 186)
@@ -20,4 +20,5 @@
 
     DO ind=1,ndomain
+      IF (.NOT. assigned_domain(ind)) CYCLE
       CALL swap_dimensions(ind)
       CALL swap_geometry(ind)
Index: codes/icosagcm/trunk/src/getin.f90
===================================================================
--- codes/icosagcm/trunk/src/getin.f90	(revision 186)
+++ codes/icosagcm/trunk/src/getin.f90	(revision 186)
@@ -0,0 +1,70 @@
+MODULE getin_mod
+
+PRIVATE
+
+  INTERFACE getin
+    MODULE PROCEDURE getin_c , getin_l, getin_i, getin_r
+  END INTERFACE getin
+ 
+PUBLIC getin
+  
+CONTAINS
+
+  SUBROUTINE getin_c(name,value)
+  USE ioipsl, ONLY : getin_=>getin
+  USE transfert_omp_mod
+  USE omp_para
+  IMPLICIT NONE
+    CHARACTER(LEN=*) :: name
+    CHARACTER(LEN=*) :: value
+
+!$OMP MASTER    
+    CALL getin_(name,value)
+!$OMP END MASTER
+    IF (omp_in_parallel()) CALL bcast_omp(value)
+  END SUBROUTINE getin_c
+
+  SUBROUTINE getin_l(name,value)
+  USE ioipsl, ONLY : getin_=>getin
+  USE transfert_omp_mod
+  USE omp_para
+  IMPLICIT NONE
+    CHARACTER(LEN=*) :: name
+    LOGICAL          :: value
+
+!$OMP MASTER    
+    CALL getin_(name,value)
+!$OMP END MASTER
+    IF (omp_in_parallel()) CALL bcast_omp(value)
+  END SUBROUTINE getin_l
+
+  SUBROUTINE getin_i(name,value)
+  USE ioipsl, ONLY : getin_=>getin
+  USE transfert_omp_mod
+  USE omp_para
+  IMPLICIT NONE
+    CHARACTER(LEN=*) :: name
+    INTEGER          :: value
+
+!$OMP MASTER    
+    CALL getin_(name,value)
+!$OMP END MASTER
+    IF (omp_in_parallel()) CALL bcast_omp(value)
+  END SUBROUTINE getin_i
+  
+  
+  SUBROUTINE getin_r(name,value)
+  USE ioipsl, ONLY : getin_=>getin
+  USE omp_para
+  USE transfert_omp_mod
+  IMPLICIT NONE
+    CHARACTER(LEN=*) :: name
+    REAL             :: value
+
+!$OMP MASTER    
+    CALL getin_(name,value)
+!$OMP END MASTER
+    IF (omp_in_parallel()) CALL bcast_omp(value)
+  END SUBROUTINE getin_r
+ 
+END MODULE getin_mod
Index: codes/icosagcm/trunk/src/guided_mod.f90
===================================================================
--- codes/icosagcm/trunk/src/guided_mod.f90	(revision 185)
+++ codes/icosagcm/trunk/src/guided_mod.f90	(revision 186)
@@ -2,4 +2,5 @@
 
   CHARACTER(LEN=255),SAVE :: guided_type
+!$OMP THREADPRIVATE(guided_type)
 
 CONTAINS
Index: codes/icosagcm/trunk/src/guided_ncar_mod.f90
===================================================================
--- codes/icosagcm/trunk/src/guided_ncar_mod.f90	(revision 185)
+++ codes/icosagcm/trunk/src/guided_ncar_mod.f90	(revision 186)
@@ -4,4 +4,5 @@
   
   INTEGER,SAVE :: case_wind
+!$OMP THREADPRIVATE(case_wind)
   
   REAL(rstd), PARAMETER :: alpha=0.0 ! tilt of solid-body rotation
@@ -46,4 +47,5 @@
     
     DO ind = 1 , ndomain
+      IF (.NOT. assigned_domain(ind)) CYCLE
       CALL swap_dimensions(ind)
       CALL swap_geometry(ind) 
Index: codes/icosagcm/trunk/src/icosa_gcm.f90
===================================================================
--- codes/icosagcm/trunk/src/icosa_gcm.f90	(revision 185)
+++ codes/icosagcm/trunk/src/icosa_gcm.f90	(revision 186)
@@ -12,8 +12,9 @@
   USE xios_mod
   USE write_field
+  USE getin_mod
   IMPLICIT NONE
   
-  TYPE(t_field),POINTER :: sum_ne(:)
-  TYPE(t_field),POINTER :: sum_ne_glo(:)
+  TYPE(t_field),POINTER,SAVE :: sum_ne(:)
+  TYPE(t_field),POINTER,SAVE :: sum_ne_glo(:)
   REAL(rstd),POINTER :: pt_sum_ne(:)
   
@@ -24,4 +25,5 @@
  
   CALL init_mpipara
+  CALL trace_off
   CALL xios_init
   CALL init_earth_const 
@@ -34,6 +36,7 @@
   CALL init_trace
 
+!$OMP PARALLEL  
+  CALL compute_geometry
   
-  CALL compute_geometry
   CALL init_disvert 
   CALL init_vertical_interp
@@ -41,5 +44,6 @@
   CALL allocate_field(sum_ne,field_T,type_real)
   
-
+!$OMP BARRIER
+!$OMP MASTER
   DO ind=1,ndomain
      
@@ -60,12 +64,11 @@
     ENDDO
   ENDDO
-
-
   
   IF (is_mpi_root) PRINT *," Diff surf",1-tot_sum/(4*Pi*radius*radius)
+!$OMP END MASTER
 
+ 
+  CALL WriteField("Ai",geom%Ai)
   
-  CALL WriteField("Ai",geom%Ai)
-
   IF (is_mpi_root) CALL write_apbp
   CALL init_time
@@ -74,6 +77,7 @@
   CALL init_timeloop
 
-!$OMP PARALLEL
+
   CALL timeloop
+
 !$OMP END PARALLEL
 
Index: codes/icosagcm/trunk/src/icosa_mod.f90
===================================================================
--- codes/icosagcm/trunk/src/icosa_mod.f90	(revision 185)
+++ codes/icosagcm/trunk/src/icosa_mod.f90	(revision 186)
@@ -2,5 +2,6 @@
 
   USE genmod
-  USE ioipsl, ONLY : getin
+!  USE ioipsl, ONLY : getin
+  USE getin_mod, ONLY : getin
   USE grid_param
   USE metric
Index: codes/icosagcm/trunk/src/kinetic.f90
===================================================================
--- codes/icosagcm/trunk/src/kinetic.f90	(revision 185)
+++ codes/icosagcm/trunk/src/kinetic.f90	(revision 186)
@@ -18,4 +18,5 @@
 
     DO ind=1,ndomain
+      IF (.NOT. assigned_domain(ind)) CYCLE
       CALL swap_dimensions(ind)
       CALL swap_geometry(ind)
Index: codes/icosagcm/trunk/src/mpi_mod.F90
===================================================================
--- codes/icosagcm/trunk/src/mpi_mod.F90	(revision 185)
+++ codes/icosagcm/trunk/src/mpi_mod.F90	(revision 186)
@@ -12,4 +12,7 @@
   INTEGER :: MPI_STATUS_SIZE 
   INTEGER :: MPI_SUM
+  INTEGER :: MPI_THREAD_SINGLE, MPI_THREAD_FUNNELED, 
+  INTEGER :: MPI_THREAD_SERIALIZED, MPI_THREAD_MULTIPLE
+  
   INTEGER,PARAMETER :: MPI_ADDRESS_KIND=KIND(INTEGER)
 #endif
@@ -21,4 +24,8 @@
 
  SUBROUTINE  MPI_INIT
+   PRINT *, 'Compiled without MPI'
+ END
+
+ SUBROUTINE  MPI_INIT_THREAD
    PRINT *, 'Compiled without MPI'
  END
@@ -69,3 +76,6 @@
  END
 
+ SUBROUTINE MPI_FREE_MEM
+ END
+
 #endif
Index: codes/icosagcm/trunk/src/mpipara.F90
===================================================================
--- codes/icosagcm/trunk/src/mpipara.F90	(revision 185)
+++ codes/icosagcm/trunk/src/mpipara.F90	(revision 186)
@@ -3,4 +3,5 @@
   INTEGER,SAVE :: mpi_rank
   INTEGER,SAVE :: mpi_size
+  INTEGER,SAVE :: mpi_threading_mode
   
   INTEGER,SAVE :: comm_icosa
@@ -13,12 +14,19 @@
   END INTERFACE allocate_mpi_buffer
 
+  INTERFACE free_mpi_buffer
+    MODULE PROCEDURE free_mpi_buffer_r2, free_mpi_buffer_r3, free_mpi_buffer_r4
+  END INTERFACE free_mpi_buffer
+
 CONTAINS
 
   SUBROUTINE init_mpipara
   USE mpi_mod
+  USE getin_mod
 #ifdef CPP_USING_XIOS
   USE xios
 #endif
   IMPLICIT NONE
+    CHARACTER(LEN=256) :: required_mode_str
+    INTEGER :: required_mode
 
     using_mpi=.FALSE.
@@ -28,6 +36,44 @@
     
     IF (using_mpi) THEN
-      CALL MPI_INIT(ierr)
-
+    
+      required_mode_str='multiple'
+      CALL getin('mpi_threading_mode',required_mode_str)
+      
+      SELECT CASE(TRIM(required_mode_str))
+        CASE ('single')
+          required_mode=MPI_THREAD_SINGLE
+        CASE ('funneled')
+          required_mode=MPI_THREAD_FUNNELED
+        CASE ('serialized')
+          required_mode=MPI_THREAD_SERIALIZED
+        CASE ('multiple')
+          required_mode=MPI_THREAD_MULTIPLE
+        CASE DEFAULT
+          PRINT*,'Bad selector for variable mpi_threading_mode  : <', TRIM(required_mode_str),  &
+                 '>  => options are <single>, <funneled>, <serialized>, <multiple>'
+          STOP
+      END SELECT
+      
+
+      IF (required_mode==MPI_THREAD_SINGLE)     PRINT*,'MPI_INIT_THREAD : MPI_SINGLE_THREAD required'
+      IF (required_mode==MPI_THREAD_FUNNELED)   PRINT*,'MPI_INIT_THREAD : MPI_THREAD_FUNNELED required'
+      IF (required_mode==MPI_THREAD_SERIALIZED) PRINT*,'MPI_INIT_THREAD : MPI_THREAD_SERIALIZED required'
+      IF (required_mode==MPI_THREAD_MULTIPLE)   PRINT*,'MPI_INIT_THREAD : MPI_THREAD_MULTIPLE required'
+
+      
+      CALL MPI_INIT_THREAD(MPI_THREAD_MULTIPLE,mpi_threading_mode,ierr)
+      
+      IF (mpi_threading_mode==MPI_THREAD_SINGLE)     PRINT*,'MPI_INIT_THREAD : MPI_SINGLE_THREAD provided'
+      IF (mpi_threading_mode==MPI_THREAD_FUNNELED)   PRINT*,'MPI_INIT_THREAD : MPI_THREAD_FUNNELED provided'
+      IF (mpi_threading_mode==MPI_THREAD_SERIALIZED) PRINT*,'MPI_INIT_THREAD : MPI_THREAD_SERIALIZED provided'
+      IF (mpi_threading_mode==MPI_THREAD_MULTIPLE)   PRINT*,'MPI_INIT_THREAD : MPI_THREAD_MULTIPLE provided'
+
+      IF (mpi_threading_mode > required_mode) mpi_threading_mode=required_mode
+
+      IF (mpi_threading_mode==MPI_THREAD_SINGLE)     PRINT*,'MPI_INIT_THREAD : MPI_SINGLE_THREAD used'
+      IF (mpi_threading_mode==MPI_THREAD_FUNNELED)   PRINT*,'MPI_INIT_THREAD : MPI_THREAD_FUNNELED used'
+      IF (mpi_threading_mode==MPI_THREAD_SERIALIZED) PRINT*,'MPI_INIT_THREAD : MPI_THREAD_SERIALIZED used'
+      IF (mpi_threading_mode==MPI_THREAD_MULTIPLE)   PRINT*,'MPI_INIT_THREAD : MPI_THREAD_MULTIPLE used'
+          
 #ifdef CPP_USING_XIOS
       CALL xios_initialize("icosagcm",return_comm=comm_icosa)
@@ -79,5 +125,16 @@
     CALL C_F_POINTER(base_ptr, buffer, (/ length /))
 
-   END SUBROUTINE allocate_mpi_buffer_r2
+  END SUBROUTINE allocate_mpi_buffer_r2
+
+  SUBROUTINE free_mpi_buffer_r2(buffer)
+  USE ISO_C_BINDING
+  USE mpi_mod
+  USE prec
+  IMPLICIT NONE
+    REAL(rstd), POINTER :: buffer(:)
+
+    CALL MPI_FREE_MEM(buffer,ierr)
+
+   END SUBROUTINE free_mpi_buffer_r2
 
   SUBROUTINE allocate_mpi_buffer_r3(buffer,length,dim3)
@@ -100,5 +157,16 @@
     CALL C_F_POINTER(base_ptr, buffer, (/ length,dim3 /))
     
-   END SUBROUTINE allocate_mpi_buffer_r3
+  END SUBROUTINE allocate_mpi_buffer_r3
+
+  SUBROUTINE free_mpi_buffer_r3(buffer)
+  USE ISO_C_BINDING
+  USE mpi_mod
+  USE prec
+  IMPLICIT NONE
+    REAL(rstd), POINTER :: buffer(:,:)
+
+    CALL MPI_FREE_MEM(buffer,ierr)
+
+  END SUBROUTINE free_mpi_buffer_r3
 
   SUBROUTINE allocate_mpi_buffer_r4(buffer,length,dim3,dim4)
@@ -123,4 +191,15 @@
     
    END SUBROUTINE allocate_mpi_buffer_r4
+
+  SUBROUTINE free_mpi_buffer_r4(buffer)
+  USE ISO_C_BINDING
+  USE mpi_mod
+  USE prec
+  IMPLICIT NONE
+    REAL(rstd), POINTER :: buffer(:,:,:)
+
+    CALL MPI_FREE_MEM(buffer,ierr)
+
+  END SUBROUTINE free_mpi_buffer_r4
    
 END MODULE mpipara
Index: codes/icosagcm/trunk/src/omega.f90
===================================================================
--- codes/icosagcm/trunk/src/omega.f90	(revision 185)
+++ codes/icosagcm/trunk/src/omega.f90	(revision 186)
@@ -13,4 +13,5 @@
     REAL(rstd),POINTER :: ps(:), u(:,:), om(:,:)
     DO ind=1,ndomain
+       IF (.NOT. assigned_domain(ind)) CYCLE
        CALL swap_dimensions(ind)
        CALL swap_geometry(ind)
Index: codes/icosagcm/trunk/src/omp_para.F90
===================================================================
--- codes/icosagcm/trunk/src/omp_para.F90	(revision 185)
+++ codes/icosagcm/trunk/src/omp_para.F90	(revision 186)
@@ -18,4 +18,6 @@
   LOGICAL,SAVE :: using_openmp
 
+  LOGICAL,PARAMETER :: omp_by_domain=.TRUE. 
+
 CONTAINS
 
@@ -23,5 +25,5 @@
   SUBROUTINE init_omp_para
   USE grid_param
-#ifdef CPP_USING_OPENMP
+#ifdef CPP_USING_OMP
   USE omp_lib
 #endif
@@ -29,5 +31,5 @@
   INTEGER :: ll_nb,i
 
-#ifdef CPP_USING_OPENMP
+#ifdef CPP_USING_OMP
   using_openmp=.TRUE.
 #else
@@ -39,39 +41,58 @@
   
 !$OMP MASTER
-#ifdef CPP_USING_OPENMP
+#ifdef CPP_USING_OMP
     omp_size=OMP_GET_NUM_THREADS()
 #endif
 !$OMP END MASTER
 !$OMP BARRIER
-#ifdef CPP_USING_OPENMP
+#ifdef CPP_USING_OMP
     omp_rank=OMP_GET_THREAD_NUM()
 #endif
-    omp_first=.FALSE.
-    omp_last=.FALSE.
-    omp_master=.FALSE.
+
+    IF (omp_by_domain) THEN
+      omp_first=.TRUE.
+      omp_last=.TRUE.
+      IF (omp_rank==0) THEN
+        omp_master=.TRUE.
+      ELSE
+        omp_master=.FALSE.
+      ENDIF
+     
+      ll_begin=1
+      ll_beginp1=2
+      ll_end=llm
+      ll_endm1=llm-1
+      ll_endp1=llm+1
+     
+    ELSE    
     
-    IF (omp_rank==0) THEN
-      omp_first=.TRUE.
-      omp_master=.TRUE.
+      omp_first=.FALSE.
+      omp_last=.FALSE.
+      omp_master=.FALSE.
+    
+      IF (omp_rank==0) THEN
+        omp_first=.TRUE.
+        omp_master=.TRUE.
+      ENDIF
+    
+      IF (omp_rank==omp_size-1) omp_last=.TRUE.
+    
+      ll_end=0
+      DO i=0,omp_rank
+        ll_begin=ll_end+1
+        ll_nb=llm/omp_size
+        IF (MOD(llm,omp_size)>i) ll_nb=ll_nb+1
+        ll_end=ll_begin+ll_nb-1
+      ENDDO
+    
+      ll_beginp1=ll_begin
+      ll_endp1=ll_end
+      ll_endm1=ll_end
+
+      IF (omp_first) ll_beginp1=ll_begin+1
+      IF (omp_last) ll_endp1=ll_endp1+1
+      IF (omp_last) ll_endm1=ll_endm1-1
+    
     ENDIF
-    
-    IF (omp_rank==omp_size-1) omp_last=.TRUE.
-    
-    ll_end=0
-    DO i=0,omp_rank
-      ll_begin=ll_end+1
-      ll_nb=llm/omp_size
-      IF (MOD(llm,omp_size)>i) ll_nb=ll_nb+1
-      ll_end=ll_begin+ll_nb-1
-    ENDDO
-    
-    ll_beginp1=ll_begin
-    ll_endp1=ll_end
-    ll_endm1=ll_end
-
-    IF (omp_first) ll_beginp1=ll_begin+1
-    IF (omp_last) ll_endp1=ll_endp1+1
-    IF (omp_last) ll_endm1=ll_endm1-1
-
 !$OMP END PARALLEL
 
@@ -91,5 +112,19 @@
   END SUBROUTINE init_omp_para
 
-  
+  FUNCTION omp_in_parallel()
+#ifdef CPP_USING_OMP
+  USE omp_lib, ONLY : omp_in_parallel_=>omp_in_parallel
+#endif
+  IMPLICIT NONE
+    LOGICAL :: omp_in_parallel
+    
+#ifdef CPP_USING_OMP
+    omp_in_parallel=omp_in_parallel_()
+#else
+    omp_in_parallel=.FALSE.
+#endif
+
+  END FUNCTION  omp_in_parallel  
+      
 END MODULE omp_para
     
Index: codes/icosagcm/trunk/src/output_field.f90
===================================================================
--- codes/icosagcm/trunk/src/output_field.f90	(revision 185)
+++ codes/icosagcm/trunk/src/output_field.f90	(revision 186)
@@ -2,15 +2,21 @@
 USE genmod
   PRIVATE
-  LOGICAL,SAVE :: xios_output    
+  LOGICAL,SAVE :: xios_output 
+!$OMP THREADPRIVATE(xios_output)     
+  LOGICAL,SAVE :: enable_io    
+!$OMP THREADPRIVATE(enable_io)     
 
-  PUBLIC xios_output,output_field_init,output_field,output_field_finalize
+  PUBLIC enable_io,xios_output,output_field_init,output_field,output_field_finalize
 
 CONTAINS 
   
   SUBROUTINE output_field_init
-  USE IOIPSL
+  USE getin_mod
   USE xios_mod
   USE write_field
   IMPLICIT NONE
+
+    enable_io=.TRUE.
+    CALL getin('enable_io',enable_io)
 
     IF (using_xios) THEN
Index: codes/icosagcm/trunk/src/physics.f90
===================================================================
--- codes/icosagcm/trunk/src/physics.f90	(revision 185)
+++ codes/icosagcm/trunk/src/physics.f90	(revision 186)
@@ -2,5 +2,5 @@
 
   CHARACTER(LEN=255) :: physics_type="automatic"
-
+!$OMP THREADPRIVATE(physics_type)
 
 CONTAINS
@@ -11,5 +11,5 @@
     USE icosa
     USE physics_dcmip_mod,init_physics_dcmip=>init_physics
-    USE physics_dry_mod
+!    USE physics_dry_mod
     IMPLICIT NONE
 
@@ -32,5 +32,5 @@
 
     CASE ('dry')
-       CALL init_physics_dry
+!       CALL init_physics_dry
 
     CASE DEFAULT
@@ -44,5 +44,5 @@
   SUBROUTINE physics(it,jD_cur,jH_cur,f_phis, f_ps, f_theta_rhodz, f_ue, f_q)
     USE icosa
-    USE physics_dry_mod
+!    USE physics_dry_mod
     USE physics_dcmip_mod, physics_dcmip=>physics
     USE etat0_mod
@@ -67,4 +67,6 @@
           !	CALL transfert_request(f_ue,req_e1_vect)
           CALL held_suarez(f_ps,f_theta_rhodz,f_ue) 
+       CASE DEFAULT
+!          PRINT*,"NO PHYSICAL PACAKAGE USED" ! FIXME MPI
        END SELECT
 
@@ -73,5 +75,5 @@
 
     CASE ('dry')
-       CALL physics_dry(it,jD_cur,jH_cur,f_phis, f_ps, f_theta_rhodz, f_ue, f_q)
+!       CALL physics_dry(it,jD_cur,jH_cur,f_phis, f_ps, f_theta_rhodz, f_ue, f_q)
 
     CASE DEFAULT
Index: codes/icosagcm/trunk/src/physics_dcmip.f90
===================================================================
--- codes/icosagcm/trunk/src/physics_dcmip.f90	(revision 185)
+++ codes/icosagcm/trunk/src/physics_dcmip.f90	(revision 186)
@@ -1,7 +1,9 @@
-	MODULE physics_dcmip_mod
+MODULE physics_dcmip_mod
   USE ICOSA
   PRIVATE
   
   INTEGER,SAVE :: testcase
+!$OMP THREADPRIVATE(testcase)
+
   PUBLIC init_physics, physics
   TYPE(t_field),POINTER :: f_out_i(:)
@@ -42,4 +44,5 @@
     CALL transfert_request(f_ue,req_e1_vect)
     DO ind=1,ndomain
+      IF (.NOT. assigned_domain(ind)) CYCLE
       CALL swap_dimensions(ind)
       CALL swap_geometry(ind)
Index: codes/icosagcm/trunk/src/pression.f90
===================================================================
--- codes/icosagcm/trunk/src/pression.f90	(revision 185)
+++ codes/icosagcm/trunk/src/pression.f90	(revision 186)
@@ -14,4 +14,5 @@
 
     DO ind=1,ndomain
+      IF (.NOT. assigned_domain(ind)) CYCLE
       CALL swap_dimensions(ind)
       CALL swap_geometry(ind)
Index: codes/icosagcm/trunk/src/theta_rhodz.f90
===================================================================
--- codes/icosagcm/trunk/src/theta_rhodz.f90	(revision 185)
+++ codes/icosagcm/trunk/src/theta_rhodz.f90	(revision 186)
@@ -16,4 +16,5 @@
 
     DO ind=1,ndomain
+      IF (.NOT. assigned_domain(ind)) CYCLE
       CALL swap_dimensions(ind)
       CALL swap_geometry(ind)
@@ -39,4 +40,5 @@
 
     DO ind=1,ndomain
+      IF (.NOT. assigned_domain(ind)) CYCLE
       CALL swap_dimensions(ind)
       CALL swap_geometry(ind)
@@ -62,4 +64,5 @@
 
     DO ind=1,ndomain
+      IF (.NOT. assigned_domain(ind)) CYCLE
       CALL swap_dimensions(ind)
       CALL swap_geometry(ind)
@@ -82,4 +85,5 @@
     INTEGER :: i,j,ij,l
     REAL(rstd),ALLOCATABLE,SAVE :: p(:,:)
+!$OMP THREADPRIVATE(p)
 
     ALLOCATE( p(iim*jjm,llm+1))
@@ -109,4 +113,5 @@
     INTEGER :: i,j,ij,l
     REAL(rstd),SAVE,ALLOCATABLE :: p(:,:)
+!$OMP THREADPRIVATE(p)
 
     ALLOCATE( p(iim*jjm,llm+1))
Index: codes/icosagcm/trunk/src/time.f90
===================================================================
--- codes/icosagcm/trunk/src/time.f90	(revision 185)
+++ codes/icosagcm/trunk/src/time.f90	(revision 186)
@@ -4,19 +4,33 @@
 
   INTEGER,SAVE :: ncid
+!$OMP THREADPRIVATE(ncid)  
   INTEGER,SAVE :: time_counter_id
+!$OMP THREADPRIVATE(time_counter_id)  
   INTEGER,SAVE :: it
+!$OMP THREADPRIVATE(it)  
 
   REAL(rstd),SAVE :: dt
+!$OMP THREADPRIVATE(dt)  
   REAL(rstd),SAVE :: write_period
+!$OMP THREADPRIVATE(write_period)  
   INTEGER,SAVE    :: itau_out, itau_adv, itau_dissip, itau_physics, itaumax
+!$OMP THREADPRIVATE(itau_out, itau_adv, itau_dissip, itau_physics, itaumax)  
   
   INTEGER,SAVE :: day_step,ndays
+!$OMP THREADPRIVATE(day_step,ndays)  
   REAL(rstd),SAVE :: jD_ref,jH_ref
+!$OMP THREADPRIVATE(jD_ref,jH_ref)  
   INTEGER,SAVE :: day_ini,day_end,annee_ref,day_ref
+!$OMP THREADPRIVATE(day_ini,day_end,annee_ref,day_ref)  
   REAL(rstd),SAVE::start_time
+!$OMP THREADPRIVATE(start_time)  
   CHARACTER(LEN=255) :: time_style
+!$OMP THREADPRIVATE(time_style)  
   INTEGER,SAVE:: an, mois, jour
+!$OMP THREADPRIVATE(an, mois, jour)  
   REAL(rstd),SAVE:: heure
+!$OMP THREADPRIVATE(heure)  
   CHARACTER (LEN=10):: calend
+!$OMP THREADPRIVATE(calend)  
 
   PUBLIC create_time_counter_header, update_time_counter, close_time_counter, init_time,  &
@@ -32,5 +46,5 @@
   SUBROUTINE init_time
   USE earth_const
-  USE ioipsl
+  USE getin_mod
   USE mpipara
   IMPLICIT NONE
@@ -38,5 +52,5 @@
 
 
-     time_style='dcmip'
+   time_style='dcmip'
    CALL getin('time_style',time_style)
 
@@ -81,5 +95,5 @@
   USE netcdf_mod
   USE prec
-  USE ioipsl
+  USE getin_mod
   USE mpipara
   IMPLICIT NONE
@@ -88,5 +102,9 @@
   REAL(rstd) :: dt
   CHARACTER(LEN=255) :: time_frequency
-  
+
+  CALL getin("dt",dt)
+
+!$OMP BARRIER
+!$OMP MASTER  
     IF (is_mpi_root) THEN 
       status = NF90_CREATE('time_counter.nc', NF90_CLOBBER, ncid)
@@ -104,8 +122,9 @@
       status = NF90_ENDDEF(ncid) 
 
-      CALL getin("dt",dt)
       status=NF90_PUT_VAR(ncid,dtid, dt)
     ENDIF
     it=0
+!$OMP END MASTER
+!$OMP BARRIER
 
   END SUBROUTINE create_time_counter_header
@@ -120,4 +139,5 @@
   REAL(rstd) ::time_array(1)
 
+!$OMP BARRIER
 !$OMP MASTER
     time_array(1)=time
@@ -129,4 +149,5 @@
     ENDIF
 !$OMP END MASTER
+!$OMP BARRIER
 
   END SUBROUTINE update_time_counter    
@@ -138,5 +159,9 @@
     INTEGER :: status
     
+!$OMP BARRIER
+!$OMP MASTER
      IF (is_mpi_root) status=NF90_CLOSE(ncid)
+!$OMP END MASTER
+!$OMP BARRIER
     
   END SUBROUTINE  close_time_counter 
